import Vue from 'vue';
import messageVue from './message.vue';
let MessageConstructor = Vue.extend(messageVue);

let instance;
let instances = [];
let seed = 1;

const Message = function (options = {}) {

    if (typeof options === 'string') {
        options = {
            message: options
        };
    };
    let id = 'message_' + seed++;
    options.onClose = function () {
        Message.close(id);
    }

    instance = new MessageConstructor({
        data: options,
    });
    instance.id = id;
    instance.$mount();
    document.body.appendChild(instance.$el);
    let verticalOffset = options.offset || 16;
    instances.forEach(item => {
        verticalOffset += item.$el.offsetHeight + 16;
    });
    instance.verticalOffset = verticalOffset;
    instance.visible = true;
    instances.push(instance);
    return instance;
}

Message.close = function (id) {
    let len = instances.length;
    let index = -1;
    for (let i = 0; i < len; i++) {
        if (id === instances[i].id) {
            index = i;
            instances.splice(i, 1);
            break;
        }
    }
    if (len <= 1 || index === -1 || index > instances.length - 1) return;
    const removedHeight = instances[index].$el.offsetHeight;
    for (let i = index; i < len - 1 ; i++) {
        let dom = instances[i].$el;
        dom.style['top'] = parseInt(dom.style['top'], 10) - removedHeight - 16 + 'px';
    }
}

export default Message;


